<script setup>
import { store } from '@/store';
import { Link, router, usePage } from '@inertiajs/vue3';
import { ref } from 'vue';
const props = defineProps({
    index: Number,
    isEngineering: Boolean,
    isChild: Boolean,
    isActive: Boolean,
    parentSaleCoeff: {
        type: Number,
        default: 0,
    },
    parentSendCoeff: {
        type: Number,
        default: 0,
    },
    parentAmount: {
        type: Number,
        default: 1,
    },
    item: Object,
});
const types = {
    1: {
        name: 'Комплектующая',
        link: 'items',
    },
    2: {
        name: 'Деталь',
        link: 'details',
    },
    3: {
        name: 'Оборудование',
        link: 'equipments',
    },
    4: {
        name: 'Доп. оборудование',
        link: 'customs',
    },
};
const state = ref({
    open: 0,
    link: types[props.item.type].link,
    type: types[props.item.type].name,
});
const changeParam = (src, item, param, value) => {
    router.post('/changeparam', {
        src: src,
        item: item,
        param: param,
        value: value,
    });
}
/* Удаляем контент и всё, куда он входит */
const deleteContent = (type, id) => {

}

const emit = defineEmits(
    ['delete']
);

const page = usePage();

const updatePivotAmount = () => {
    router.post(route('comps.pivot.amount'), {
        id: props.item.pivot.id,
        amount: props.item.pivot.amount,
    }, {
        preserveScroll: true,
    });
}

const updatePivotCoeff = () => {
    router.post(route('comps.pivot.coeff'), {
        id: props.item.pivot.id,
        coeff: props.item.pivot.coeff,
    }, {
        preserveScroll: true,
    });
}

const updatePivotComment = () => {
    router.post(route('comps.pivot.comment'), {
        id: props.item.pivot.id,
        comment: props.item.pivot.comment,
    }, {
        preserveScroll: true,
    });
}


function formatMoney(amount, decimalCount = 2, decimal = ".", thousands = ",") {
    try {
        decimalCount = Math.abs(decimalCount);
        decimalCount = isNaN(decimalCount) ? 2 : decimalCount;
        const negativeSign = amount < 0 ? "-" : "";
        let i = parseInt(amount = Math.abs(Number(amount) || 0).toFixed(decimalCount)).toString();
        let j = (i.length > 3) ? i.length % 3 : 0;
        return negativeSign +
            (j ? i.substr(0, j) + thousands : '') +
            i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousands) +
            (decimalCount ? decimal + Math.abs(amount - i).toFixed(decimalCount).slice(2) : "");
    } catch (e) {
        console.log(e)
    }
};

</script>
<template>
    <tr class="item" :class="{
        '_hidden': props.isChild && !props.isActive,
        '_open': state.open,
        '_child': props.isChild,
        '_item': props.item.type == 1,
    }">
        <td>
            <div class="table-icons">
                <div class="table-icon" @click="emit('delete')">
                    <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 0 24 24"
                        fill="none">
                        <path d="M3 6.98996C8.81444 4.87965 15.1856 4.87965 21 6.98996" stroke="#000000"
                            stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                        <path
                            d="M8.00977 5.71997C8.00977 4.6591 8.43119 3.64175 9.18134 2.8916C9.93148 2.14146 10.9489 1.71997 12.0098 1.71997C13.0706 1.71997 14.0881 2.14146 14.8382 2.8916C15.5883 3.64175 16.0098 4.6591 16.0098 5.71997"
                            stroke="#000000" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                        <path d="M12 13V18" stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                            stroke-linejoin="round" />
                        <path
                            d="M19 9.98999L18.33 17.99C18.2225 19.071 17.7225 20.0751 16.9246 20.8123C16.1266 21.5494 15.0861 21.9684 14 21.99H10C8.91389 21.9684 7.87336 21.5494 7.07541 20.8123C6.27745 20.0751 5.77745 19.071 5.67001 17.99L5 9.98999"
                            stroke="#000000" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                    </svg>
                </div>
            </div>
        </td>
        <td>
            {{ props.item.article }}
        </td>
        <td v-if="false">
            {{ index + 1 }}
        </td>
        <td>
            <div class="thumbnail" v-if="props.item.image"><img :src='"/photos/" + props.item.image'></div>
        </td>
        <td>
            {{ props.item.name }}
        </td>
        <td>
            {{ page.props.mats[props.item.material_id].short_name }}
        </td>
        <td>
            <input type="number" class="input-table" v-model="props.item.pivot.amount" @change="updatePivotAmount()">
        </td>
        <td>
            {{ page.props.mets[props.item.measure_unit_id].short_name }}
        </td>
        <td v-html="formatMoney(props.item.calc_weight * props.item.pivot.amount, 2, '.', ' ')"></td>
        <td v-html="props.item.price" v-if="store.pricesOpen">
        </td>
        <td v-if="store.coeffsOpen" v-html="props.item.coeff_sale"></td>
        <td v-if="store.coeffsOpen" v-html="props.item.coeff_send"></td>
        <td v-html="formatMoney((props.item.price * (1 + +props.item.coeff_sale) * (1 + +props.item.coeff_send)), 2, '.', ' ')" v-if="store.pricesOpen">
        </td>
        <td>
            <input type="number" class="input-table" v-model="props.item.pivot.coeff" @change="updatePivotCoeff()">
        </td>
        <td v-html="formatMoney((props.item.pivot.amount * props.item.price * (1 + +props.item.coeff_sale) * (1 + +props.item.coeff_send)), 2, '.', ' ')">
        </td>
        <td>
            <textarea style="min-width: 200px; font-size: 12px;" v-model="props.item.pivot.comment" @change="updatePivotComment()"></textarea>
        </td>
    </tr>
</template>
